#ifndef DATA
#define DATA

#include <vector>
#include <map>

//very simple data strucutre to store 3d points
typedef struct Vector3{
  float x;
  float y;
  float z;
  Vector3(float in_x, float in_y, float in_z) : x(in_x), y(in_y), z(in_z) {}
  Vector3() { x = y = z = 0.0;}
} Vector3;

//data structure to store triangle - 
//note that v1, v2, and v3 are indexes into the vertex array
typedef struct Tri{
  int v1;
  int v2;
  int v3;
  Vector3 normal;
  Vector3 color;
  Tri(int in_v1, int in_v2, int in_v3) : v1(in_v1), v2(in_v2), v3(in_v3), normal(0, 1, 0){}
  Tri() : normal(0, 1, 0) {}
} Tri;

typedef struct Norm{
   std::vector<Vector3 *> touchers;
   Vector3 normal;
} Norm;


typedef struct materialStruct {
  float ambient[4];
  float diffuse[4];
  float specular[4];
  float shininess[1];
} materialStruct;

typedef struct tagVERTEX
{
	float x, y, z;
	float u, v;
} VERTEX;

typedef struct tagTRIANGLE
{
   int textureId;
   int oro, end;
   VERTEX normal;
	VERTEX vertex[3];

   float getXMin() {
      float rtn = 1000000.0;
      //printf("\nX...");
      for (int i = 0; i < 3; i++) {
         //printf("%.1f ", vertex[i].x);
         if (vertex[i].x < rtn) {
            //printf("(%.1f) ", vertex[i].x);
            rtn = vertex[i].x;
         }
      }
      //printf("\n");
      return rtn;
   }
   float getXMax() {
      float rtn = -INT_MAX;
      for (int i = 0; i < 3; i++)
         if (vertex[i].x > rtn)
            rtn = vertex[i].x;
      return rtn;
   }
   float getZMax() {
      float rtn = -INT_MAX;
      for (int i = 0; i < 3; i++)
         if (vertex[i].z > rtn)
            rtn = vertex[i].z;
      return rtn;
   }
   float getZMin() {
      float rtn = INT_MAX;
      //printf("\nZ...");
      for (int i = 0; i < 3; i++) {
         //printf("%.1f ", vertex[i].z);
         if (vertex[i].z < rtn) {
            rtn = vertex[i].z;
            //printf("(%.1f) ", vertex[i].z);
         }
      }
      //printf("\n");
      return rtn;
   }
} TRIANGLE;

/* Represents a room, cube or any enclosed volume */
typedef struct tagSECTOR
{
	int numtriangles;          //The number of triangles in the sector
	TRIANGLE* triangle;        //Pointer ot array of triangles
} SECTOR;

typedef struct Image {
  unsigned long sizeX;
  unsigned long sizeY;
  char *data;
} Image;

typedef struct RGB {
  GLubyte r;
  GLubyte g; 
  GLubyte b;
} RGB;

#endif
