#ifndef GLOBE_H
#define GLOBE_H


//#include <GLUT/glut.h>
#include <glut.h>

#include "datastructures.h"


#define FLT_MIN 1.1754E-38F
#define FLT_MAX 1.1754E+38F
#define HOROZ 1
#define VERT  0

//stl vector to store all the triangles in the mesh
std::vector<Tri *> Triangles;
//stl vector to store all the vertices in the mesh
std::vector<Vector3 *> Vertices;
//stl vector to store all the NORMALZZZZ
std::vector<Vector3 *> Normals;
//fun
std::vector<Norm *> VertNormals;

//for computing the center point and extent of the model
Vector3 center;
Vector3 rVect;
Vector3 cross;
Vector3 gaze;
Vector3 w;
Vector3 up;
Vector3 u;
VERTEX eye;
VERTEX futureEye;

materialStruct *mat;
materialStruct *matbackup;

//other globals
int GW;
int GH;
int click;
int selected = -1;

Image *TextureImage;
//RGB myimage[64][64];
//RGB* pixel;

bool mapMode = false;
bool startState = true;
bool endState = false;
bool up_p = false, down_p = false, left_p = false, right_p = false;

float light_pos[4] = {-1.0, 0.8, -1.0, 1.0};
float light_amb[4] = {0.8, 0.8, 0.8, 1.0};
float light_diff[4] = {0., 0.0, 0.0, 1.0};
float light_spec[4] = {0.0, 0.0, 0.0, 1.0};

float max_x, max_y, max_z, min_x, min_y, min_z;
float max_extent;
float theta = 0.0;
float scale = 1.0;
float stepConst = 0.02;
float myMatrix[16];
float alpha = 0.0;
float beta = -(3.14)/2;
float R;

float lax_0N, lay_0N, laz_0N;
float lax_0, lay_0, laz_0;
float lax, lay, laz;
float camtransx, camtransy, camtransz;

//World Vars
SECTOR sector1;				// Our Model Goes Here:

#endif
