//basic program to read in a mesh file (of .m format from H. Hoppe)
//Hh code modified by ZJW for csc 471
//Texture code from lab 11
//Basic Idea of world format and parser code from Nehe Tutorial
//The idea for the movement code came from a lighthouse3d tutorial
//Everything else, Seth Marinello

#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <iostream>
#include <fstream>
#include <assert.h>
#include <math.h>


#include "globals.h"
#include "materials.h"
#include "datastructures.h"


//#include <glut.h>

using namespace std;

//forward declarations of functions

void drawTri(Tri * t);
void drawObjects();
void display();
void display_map();
void mouse(int button, int state, int x, int y);
void turn (int x, int y);
void cross_product(Vector3 *a, Vector3 *b, Vector3 *c);
float dot_product(Vector3 *a, Vector3 *b);
float p2i_x(int x);
float p2i_y(int y);
float i2w_x(float x);
float i2w_y(float y);
float vlength(Vector3 *a);
void printFirstThree();
void CalcVectNormals();
void drawGround();
void setMat(materialStruct *);
void readstr(FILE *f,char *string);
void SetupWorld();
int collide(VERTEX*, VERTEX*, int);
int ImageLoad(char *filename, Image *image);
GLvoid LoadTexture(char* image_file, int tex_id);
void init_tex();
void processMovement();


void pos_light() {
  //set the light's position
  glMatrixMode(GL_MODELVIEW);
  glLightfv(GL_LIGHT0, GL_POSITION, light_pos);
}

void drawWorld() {
   int numtriangles;
   float x_m, y_m, z_m, u_m, v_m;

   numtriangles = sector1.numtriangles;

   if (mapMode) {
     setMat(&RedFlat);
     glBindTexture(GL_TEXTURE_2D, 10);
     glPushMatrix();
         glTranslatef(eye.x, eye.y , eye.z);
         glutSolidSphere(0.3, 10, 10);
     glPopMatrix();
   }

   setMat(&White);
   glBindTexture(GL_TEXTURE_2D, 10);
   glBegin(GL_POLYGON);
      glVertex3f(100, 0, 100);
      glVertex3f(-100, 0, 100);
      glVertex3f(-100, 0, -100);
      glVertex3f(100, 0 , -100);
   glEnd();

   for (int loop_m = 0; loop_m < numtriangles; loop_m++)
	{
      if (loop_m == selected) {
         setMat(&RedFlat);
      }
      glBindTexture(GL_TEXTURE_2D, sector1.triangle[loop_m].textureId);
		glBegin(GL_TRIANGLES);
			
         glNormal3f( 0.0f, 0.0f, 1.0f);
			x_m = sector1.triangle[loop_m].vertex[0].x;
			y_m = sector1.triangle[loop_m].vertex[0].y;
			z_m = sector1.triangle[loop_m].vertex[0].z;
			u_m = sector1.triangle[loop_m].vertex[0].u;
			v_m = sector1.triangle[loop_m].vertex[0].v;
			glTexCoord2f(u_m,v_m); 
         glVertex3f(x_m,y_m,z_m);
			
			x_m = sector1.triangle[loop_m].vertex[1].x;
			y_m = sector1.triangle[loop_m].vertex[1].y;
			z_m = sector1.triangle[loop_m].vertex[1].z;
			u_m = sector1.triangle[loop_m].vertex[1].u;
			v_m = sector1.triangle[loop_m].vertex[1].v;
			glTexCoord2f(u_m,v_m); 
         glVertex3f(x_m,y_m,z_m);
			
			x_m = sector1.triangle[loop_m].vertex[2].x;
			y_m = sector1.triangle[loop_m].vertex[2].y;
			z_m = sector1.triangle[loop_m].vertex[2].z;
			u_m = sector1.triangle[loop_m].vertex[2].u;
			v_m = sector1.triangle[loop_m].vertex[2].v;
		 	glTexCoord2f(u_m,v_m); 
         glVertex3f(x_m,y_m,z_m);
		glEnd();
      setMat(&White);
	}

}
void drawMenu(int i) {
   setMat(&White);
   glBindTexture(GL_TEXTURE_2D, i);
   glBegin(GL_POLYGON);
      glVertex3f(-20, 0, -20);
	   glTexCoord2f(0, 0);
      
      glVertex3f(20, 0 , -20);
	   glTexCoord2f(0, 1);

      glVertex3f(20, 0, 20);
	   glTexCoord2f(1, 1);
      
      glVertex3f(-20, 0, 20);
	   glTexCoord2f(1, 0);
      
   glEnd();
}

void reshape(int w, int h) {
  GW = w;
  GH = h;

  
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();

  gluPerspective(75.0,(float)w/(float)h, 0.1, 100.0);

  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();
  glViewport(0, 0, w, h);

  glutPostRedisplay();
}

void display() {

  processMovement();

  glClear(GL_COLOR_BUFFER_BIT);

  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();

  glClear(GL_DEPTH_BUFFER_BIT);

  if (mapMode) {
     gluLookAt(eye.x, 10, eye.z, lax, lay, laz, 0, 1, 0);
  }  
  else if (startState || endState) {
     gluLookAt(0, 20, 1, 0, 0, 2, 0, 1, 0);
  }
  else {
     gluLookAt(eye.x, eye.y, eye.z, lax, lay, laz, 0, 1, 0);
  }
 
  glPushMatrix();
  if (startState) {
      drawMenu(11);
  }
  else if (endState) {
      drawMenu(12);
  }
  else { 
      drawWorld();
  }
  glPopMatrix();
  
  glutSwapBuffers();

  for (int i = 100000; i > 0; i--){;}

}


void calc_u() {
   float gazeLength, ulength;

   gaze.x = (lax - eye.x);
   gaze.y = (lay - eye.y);
   gaze.z = (laz - eye.z);
   gazeLength = vlength(&gaze);
   gaze.x /= gazeLength;
   gaze.y /= gazeLength;
   gaze.z /= gazeLength;

   w.x = -1 * gaze.x;
   w.y = -1 * gaze.y;
   w.z = -1 * gaze.z;
   cross_product(&w, &up, &u);
   ulength = vlength(&u);
   u.x /= ulength;
   u.y /= ulength;
   u.z /= ulength;
   
}

void keyboard(unsigned char key, int x, int y) {
   if (!startState && !endState) {
         if (key == 'h') {
            printf("Help - WASD moves about, left click to rotate camera");
         }
         else if (key == 'm') {
            mapMode = !mapMode;
         }
   }
}

void pressKey(int key, int x, int y) {
	switch (key) {
		case GLUT_KEY_LEFT  : left_p  = true;break;
		case GLUT_KEY_RIGHT : right_p = true;break;
		case GLUT_KEY_UP    : up_p    = true;break;
		case GLUT_KEY_DOWN  : down_p  = true;break;
	}
}

void releaseKey(int key, int x, int y) {
	switch (key) {
		case GLUT_KEY_LEFT  : left_p  = false;break;
		case GLUT_KEY_RIGHT : right_p = false;break;
		case GLUT_KEY_UP    : up_p    = false;break;
		case GLUT_KEY_DOWN  : down_p  = false;break;
	}
}

int main( int argc, char** argv ) {

   //set up my window
   glutInit(&argc, argv);
   glutInitDisplayMode(GLUT_RGBA | GLUT_DOUBLE | GLUT_DEPTH);
   glutInitWindowSize(800, 600); 
   glutInitWindowPosition(100, 100);
   glutCreateWindow("Oh Maria! Magical Maze Mania");
   glClearColor(0.1, 0.1, 0.1, 1.0);
   glClearDepth(1.0);
  
   //register glut callback functions
   glutIgnoreKeyRepeat(1);
   glutDisplayFunc( display );
   glutReshapeFunc( reshape );
   glutKeyboardFunc( keyboard );
   glutSpecialFunc( pressKey );
	glutSpecialUpFunc( releaseKey );
   glutIdleFunc( display );

   glutMouseFunc( mouse );  
   //glutMotionFunc( turn );

   //enable z-buffer
   glEnable(GL_DEPTH_TEST);
   glEnable(GL_TEXTURE_2D);

  //Setup Lighting
   glEnable(GL_LIGHTING);
   glEnable(GL_LIGHT0);

   glLightfv(GL_LIGHT0, GL_DIFFUSE, light_diff);
   glLightfv(GL_LIGHT0, GL_AMBIENT, light_amb);
   glLightfv(GL_LIGHT0, GL_SPECULAR, light_spec);
   glShadeModel(GL_FLAT);

   //initialization
   max_x = max_y = max_z = FLT_MIN;
   min_x = min_y = min_z = FLT_MAX;

   lax = eye.x = futureEye.x = 1.5;
   lay = eye.y = futureEye.y = 0.5;
   eye.z = futureEye.z = 1.5;
   laz  = eye.z - 0.2;

   up.x = up.z = 0;
   up.y = 1;
  
   max_extent = 1.0;
   click = GLUT_RIGHT_BUTTON;

   LoadTexture("Data/wall0.bmp", 0);
   LoadTexture("Data/wall1.bmp", 1);
   LoadTexture("Data/wall2.bmp", 2);
   LoadTexture("Data/wall3.bmp", 3);
   LoadTexture("Data/wall4.bmp", 4);

   LoadTexture("Data/end.bmp", 9);

   LoadTexture("Data/blank.bmp", 10);
   LoadTexture("Data/menu1.bmp", 11);
   LoadTexture("Data/menu2.bmp", 12);
   SetupWorld();

   glutMainLoop();
}

void mouse(int button, int state, int x, int y) {
	
   click = button;
   
   if (button == GLUT_LEFT_BUTTON && state == GLUT_DOWN) {
      if (startState) {
         startState = false;
      }
      if (endState) {
         exit(0);
      }
   }
   glutPostRedisplay();
}

void turn (int x, int y) {
   float fy = GH - 1 -y;
   float talpha, tbeta;
	
   talpha = alpha;
   tbeta = beta;

   //talpha += (3.14/180) * ((fy - oldy) * 180) / GH; //Y temp
   //tbeta  += (3.14/180) * ((x  - oldx) * 180) / GW; //X temp

   talpha += (3.14/180) * ((y) * 180) / GH; //Y temp
   tbeta  += (3.14/180) * ((x) * 180) / GW; //X temp
   //if (talpha <= (3.14/4) && talpha >= -(3.14/4)) {
   alpha = talpha;
   beta = tbeta;
   //}
   
   lax = (1 * cos(beta) * cos(alpha)) + eye.x;
   lay = (1 * sin(alpha)) + eye.y;
   laz = (1 * cos(alpha) * cos((3.14/2) - beta)) + eye.z;

   lax_0 = lax_0N;
   lay_0 = lay_0N;
   laz_0 = laz_0N;

   calc_u();

   glutPostRedisplay();
}

float vlength(Vector3 *a) {
   return sqrt((a->x * a->x) + (a->y * a->y) 
					+ (a->z *a->z));
}

float dot_product(VERTEX *a, VERTEX *b) {
   float rtn;
	
   rtn = (a->x * b->x) + (a->y * b->y) + (a->z * b->z);
	return rtn;
}

void cross_product(Vector3 *a, Vector3 *b, Vector3 *c) {
	
   c->x = ((a->y * b->z) - (a->z * b->y));
   c->y = ((a->z * b->x) - (a->x * b->z));
   c->z = ((a->x * b->y) - (a->y * b->x));
}

void cross_product(VERTEX *a, VERTEX *b, VERTEX *c) {
	
   c->x = ((a->y * b->z) - (a->z * b->y));
   c->y = ((a->z * b->x) - (a->x * b->z));
   c->z = ((a->x * b->y) - (a->y * b->x));
}

void CalcTriangleNormal(tagTRIANGLE *victim) {
	
   float len;
	
   VERTEX *base = &(victim->vertex[0]);   
   VERTEX *branch1 = &(victim->vertex[1]);
   VERTEX *branch2 = &(victim->vertex[2]);
	
   VERTEX *res1 = new VERTEX();
   VERTEX *res2 = new VERTEX();
   VERTEX *res3 = new VERTEX();
	
   res2->x = branch2->x - base->x;
   res2->y = branch2->y - base->y;
   res2->z = branch2->z - base->z;
	
   res1->x = branch1->x - base->x;
   res1->y = branch1->y - base->y;
   res1->z = branch1->z - base->z;
   
   cross_product(res1, res2, res3);
	
   len = sqrt((res3->x * res3->x) + (res3->y * res3->y)
				  + (res3->z * res3->z));
	
   res3->x /= len;
   res3->y /= len;
   res3->z /= len;
	
   victim->normal.x = res3->x;
   victim->normal.y = res3->y;
   victim->normal.z = res3->z;

   delete res1;
   delete res2;
   delete res3;   
}

float p2i_x(int x) {
	return (2/(float)GW*((float)x -((float)GW - 1)/2));
}

float p2i_y(int y) {
   return 2/(float)GH*((float)y - ((float)GH - 1)/2);
}

float i2w_x(float x) {
	float r = (float)GW/(float)GH;
	float l = -(float)GW/(float)GH;
	
	return ((r-l)/2)*((float)x - ((-r-l)/(r-l)));
}

float i2w_y(float y) {
	float t = 1;
	float b = -1;
	
	return ((t-b)/2)*((float)y - ((-t-b)/(t-b)));
}

void setMat(materialStruct *matl) {
   glMaterialfv(GL_FRONT, GL_AMBIENT, matl->ambient);
   glMaterialfv(GL_FRONT, GL_DIFFUSE, matl->diffuse);
   glMaterialfv(GL_FRONT, GL_SPECULAR, matl->specular);
   glMaterialfv(GL_FRONT, GL_SHININESS, matl->shininess);
}

void readstr(FILE *f,char *string)
{
	do
	{
    		fgets(string, 255, f);
	} while ((string[0] == '/') || (string[0] == '\n'));
	return;
}

void SetupWorld()
{
	float x, y, z, u, v;
	int numtriangles;
	FILE *filein;
	char oneline[255];
   /*Load a custom Maze if there is one */
   filein = fopen("Data/Custom.txt", "rt");
   /*Otherwise load the standard maze */
   if (filein == NULL) {
	   filein = fopen("Data/World.txt", "rt");				// File To Load World Data From
   }

   if (filein == NULL) {
      printf("World file failed to read\n");
   }
	readstr(filein,oneline);
	sscanf(oneline, "NUMPOLLIES %d\n", &numtriangles);

	sector1.triangle = new TRIANGLE[numtriangles];
	sector1.numtriangles = numtriangles;
   //Load the number of triangles defined by numpollies into our sector.
	for (int loop = 0; loop < numtriangles; loop++)
   {
      //Add 3 vertices and their texture coordinates to each triangle
		for (int vert = 0; vert < 3;)
		{
			readstr(filein,oneline);
         
         if (oneline[0] == '@') {
            sector1.triangle[loop].oro = atoi(oneline + 2);
         }
         else if (oneline[0] == '&') {
            sector1.triangle[loop].textureId = atoi(oneline + 2);
         }
         else if (oneline[0] == '$') {
            sector1.triangle[loop].end = atoi(oneline + 2);
         }
         else {
            //Parse the data into temp vars
			   sscanf(oneline, "%f %f %f %f %f", &x, &y, &z, &u, &v);
            //Store the temps
			   sector1.triangle[loop].vertex[vert].x = x;
			   sector1.triangle[loop].vertex[vert].y = y;
			   sector1.triangle[loop].vertex[vert].z = z;
			   sector1.triangle[loop].vertex[vert].u = u;
			   sector1.triangle[loop].vertex[vert].v = v;
            vert++;
         }
      }
      CalcTriangleNormal(&(sector1.triangle[loop]));
   }
	fclose(filein);
	return;
}

int collide(VERTEX *current, VERTEX *future, int flip) {
   
   float c_result, f_result;
   VERTEX dist;
   VERTEX p;
   TRIANGLE *tri;
   float offset = 0.3;

   for(int loop = 0; loop < sector1.numtriangles; loop ++) {
     tri = &sector1.triangle[loop];
     
     if (future->x < current->x) {   
         p.x = (future->x - flip * offset);
     }
     else {
         p.x = (future->x + flip * offset);
     }
     if (future->z < current->z) {
         p.z = (future->z - flip * offset);
     }
     else {
         p.z = (future->z + flip * offset);
     }
     //dist.x =  future->x - tri->vertex[0].x;
     //dist.y =  future->y - tri->vertex[0].y;
     //dist.z =  future->z - tri->vertex[0].z;

     //f_result = dot_product(&(tri->normal), &dist);

     //if (f_result > stepConst) {
       // p.x = (-1 * f_result * tri->normal.x) + future->x;  
       // p.y = (-1 * f_result * tri->normal.y) + future->y;  
       // p.z = (-1 * f_result * tri->normal.z) + future->z;  
       
        
     if ((tri->oro == HOROZ && p.x >= tri->getXMin()  && p.x <= tri->getXMax())) {
        if ((current->z > tri->getZMin() && p.z <= tri->getZMin()) 
         || (current->z < tri->getZMin() && p.z >= tri->getZMin())) {
            if (tri->end == 1 && !mapMode) {
               printf("Oh Maria!\n");
               endState = true;
            }
            return true;
        }
      }
     if ((tri->oro == VERT && p.z >= tri->getZMin()  && p.z <= tri->getZMax())) {
        if ((current->x > tri->getXMin() && p.x <= tri->getXMin()) 
         || (current->x < tri->getXMin() && p.x >= tri->getXMin())) {
            //printf("&&&& %.1f, %.1f - %.1f, %.1f ~ %.1f, %.1f\n"tri->getXMin(), tri->getXMax(), tri->getZMin(),tri->getZMax(), p.x, p.z);
            if (tri->end == 1 && !mapMode) {
               printf("Oh Maria!\n");
               endState = true;
            }
           return true;
        }
     }
   }
   return false;
}

//routines to load in a bmp files - must be 2^nx2^m and a 24bit bmp
GLvoid LoadTexture(char* image_file, int texID) { 
  
  TextureImage = (Image *) malloc(sizeof(Image));
  if (TextureImage == NULL) {
    printf("Error allocating space for image");
    exit(1);
  }
  cout << "trying to load " << image_file << endl;
  if (!ImageLoad(image_file, TextureImage)) {
    exit(1);
  }  
  /*  2d texture, level of detail 0 (normal), 3 components (red, green, blue),            */
  /*  x size from image, y size from image,                                              */    
  /*  border 0 (normal), rgb color data, unsigned byte data, data  */ 
  glBindTexture(GL_TEXTURE_2D, texID);
  glTexImage2D(GL_TEXTURE_2D, 0, 3,
    TextureImage->sizeX, TextureImage->sizeY,
    0, GL_RGB, GL_UNSIGNED_BYTE, TextureImage->data);
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_NEAREST); /*  cheap scaling when image bigger than texture */    
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_NEAREST); /*  cheap scaling when image smalled than texture*/
  
}


/* BMP file loader loads a 24-bit bmp file only */

/*
* getint and getshort are help functions to load the bitmap byte by byte
*/
static unsigned int getint(FILE *fp) {
  int c, c1, c2, c3;
  
  /*  get 4 bytes */ 
  c = getc(fp);  
  c1 = getc(fp);  
  c2 = getc(fp);  
  c3 = getc(fp);
  
  return ((unsigned int) c) +   
    (((unsigned int) c1) << 8) + 
    (((unsigned int) c2) << 16) +
    (((unsigned int) c3) << 24);
}

static unsigned int getshort(FILE *fp){
  int c, c1;
  
  /* get 2 bytes*/
  c = getc(fp);  
  c1 = getc(fp);
  
  return ((unsigned int) c) + (((unsigned int) c1) << 8);
}

/*  quick and dirty bitmap loader...for 24 bit bitmaps with 1 plane only.  */

int ImageLoad(char *filename, Image *image) {
  FILE *file;
  unsigned long size;                 /*  size of the image in bytes. */
  unsigned long i;                    /*  standard counter. */
  unsigned short int planes;          /*  number of planes in image (must be 1)  */
  unsigned short int bpp;             /*  number of bits per pixel (must be 24) */
  char temp;                          /*  used to convert bgr to rgb color. */
  
  /*  make sure the file is there. */
  if ((file = fopen(filename, "rb"))==NULL) {
    printf("File Not Found : %s\n",filename);
    return 0;
  }
  
  /*  seek through the bmp header, up to the width height: */
  fseek(file, 18, SEEK_CUR);
  
  /*  No 100% errorchecking anymore!!! */
  
  /*  read the width */    image->sizeX = getint (file);
  
  /*  read the height */ 
  image->sizeY = getint (file);
  
  /*  calculate the size (assuming 24 bits or 3 bytes per pixel). */
  size = image->sizeX * image->sizeY * 3;
  
  /*  read the planes */    
  planes = getshort(file);
  if (planes != 1) {
    printf("Planes from %s is not 1: %u\n", filename, planes);
    return 0;
  }
  
  /*  read the bpp */    
  bpp = getshort(file);
  if (bpp != 24) {
    printf("Bpp from %s is not 24: %u\n", filename, bpp);
    return 0;
  }
  
  /*  seek past the rest of the bitmap header. */
  fseek(file, 24, SEEK_CUR);
  
  /*  read the data.  */
  image->data = (char *) malloc(size);
  if (image->data == NULL) {
    printf("Error allocating memory for color-corrected image data");
    return 0; 
  }
  
  if ((i = fread(image->data, size, 1, file)) != 1) {
    printf("Error reading image data from %s.\n", filename);
    return 0;
  }
  
  for (i=0;i<size;i+=3) { /*  reverse all of the colors. (bgr -> rgb) */
    temp = image->data[i];
    image->data[i] = image->data[i+2];
    image->data[i+2] = temp;
  }
  
  fclose(file); /* Close the file and release the filedes */
  
  /*  we're done. */
  return 1;
}

void processMovement() {
   if (up_p == true) {
      calc_u();
      futureEye.x = eye.x;
      futureEye.y = eye.y;
      futureEye.z = eye.z;

      futureEye.x -= stepConst * w.x;   
      futureEye.y -= stepConst * w.y;   
      futureEye.z -= stepConst * w.z;

      if (!collide(&eye, &futureEye, 1)) {
         eye.x = futureEye.x;
         eye.y = futureEye.y;
         eye.z = futureEye.z;
         lax  -= stepConst * w.x; 
         lay  -= stepConst * w.y; 
         laz  -= stepConst * w.z;
      }
   }
   else if (down_p == true) {
      calc_u();
      futureEye.x = eye.x;
      futureEye.y = eye.y;
      futureEye.z = eye.z;

      futureEye.x += stepConst * w.x;   
      futureEye.y += stepConst * w.y;   
      futureEye.z += stepConst * w.z;

      if (!collide(&eye, &futureEye, 1)) {
         eye.x = futureEye.x;
         eye.y = futureEye.y;
         eye.z = futureEye.z;
         lax  += stepConst * w.x; 
         lay  += stepConst * w.y; 
         laz  += stepConst * w.z;
      }
   }
   if (left_p == true) {
      turn(-5, 0);
   }
   if (right_p == true) {
      turn(5, 0);
   }

}
